/*
 * UpdateParams
 * 	version 1.0.0
 */
#ifndef UPDATEPARAMS_H
#define UPDATEPARAMS_H

#include <string>
#include <set>
#include <vector>

typedef	std::set<std::string>	ExtCollection;
typedef	std::vector<std::string>	ScriptCollection;

class UpdateParams {
public:
	UpdateParams() :
		Extensions(), Scripts(), Dir1(), Dir2(),
		Direction(NORMAL), Overwrite(EXISTS),
		DoExec(false), SkipView(false),
		ShowHelp(false), ShowVersion(false), Debug(false), errorstatus(NOERROR)
		{}
	~UpdateParams() {}
	/* p[^Zbg */
	void Set(int argc, char * argv[]);
	/* gp@\ */
	void Usage(void) const;
	/* G[Xe[^XԂ */
	typedef enum {
		NOERROR, MISSING, EQUALS, SHOWHELP, ERROR
	} ERRORSTATUS;
	ERRORSTATUS ErrorStatus(void) const;
private:
	/* p[^Zbg */
	void set(std::string);
	/* POSIXtpXԂ */
	std::string fullpath(const std::string &) const;
	/* XNvgt@Cp[^ǂݍ */
	void load_scripts(void);
	void load_script(const std::string &);

public:
	std::string	Dir1;		/* ΏۃfBNgSRC */
	std::string	Dir2;		/* ΏۃfBNgDST */
	ExtCollection	Extensions;	/* gq̈ꗗ */
	ScriptCollection	Scripts;	/* XNvgt@C̈ꗗ */
	
	bool	Debug;
	bool	DoExec;
	bool	SkipView;
	bool	ShowHelp;
	bool	ShowVersion;
	typedef enum {
		NORMAL, REV, BOTH
	} DIRECTION;
	DIRECTION	Direction;
	typedef enum {
		ADD, EXISTS, NOTEXISTS
	} OVERWRITE;
	OVERWRITE	Overwrite;
private:
	ERRORSTATUS	errorstatus;
}; /* end of class UpdateParams */

#endif	/* #ifndef UPDATEPARAMS_H */
/*-------1---------2---------3---------4---------5---------6---------7---------8---------9--------*/
/*  end of text */
