/*
 * USAGE>update [-xrne] <dir1> <dir2>
 *	Options:-x	XVs
 *		-m	o@ɎQƂ
 *		-r	t@ɎQƂ
 *		-a	݂Ȃt@CRs[
 *		-e	݂t@Ĉ(*)
 *		-n	݂Ȃt@Ĉ
 * o:
 *	DIR1=****************************
 *	DIR2=****************************
 *	D/F DIR1                 DIR2                 FileName
 *	---+--------------------+--------------------+-----------------------------
 *	F   YYYY/MM/DD hh:mm:ss  YYYY/MM/DD hh:mm:ss  ****************************
 *	F   YYYY/MM/DD hh:mm:ss  YYYY/MM/DD hh:mm:ss  ****************************
 *	F   YYYY/MM/DD hh:mm:ss  YYYY/MM/DD hh:mm:ss  ****************************
 *	F   YYYY/MM/DD hh:mm:ss  YYYY/MM/DD hh:mm:ss  ****************************
 *	F   YYYY/MM/DD hh:mm:ss  YYYY/MM/DD hh:mm:ss  ****************************
 */
/*-------1---------2---------3---------4---------5---------6---------7---------8---------9--------*/
#include <string>
#include <iostream>
#include <stdexcept>

#include "DirectoryEntry.hpp"
#include "UpdateParams.hpp"
#include "UpdateCommand.hpp"

const std::string	Version = "Update 1.1.0";
const std::string	Copyright = "Copyright (C) 2008-2009 T.'GORI'Takeuchi";

using namespace std;

int main(int argc, char * argv[])
{
	UpdateParams	params;
	try {
		params.Set(argc, argv);
	} catch (std::invalid_argument & ex_ia) {
		cout << endl << "Invalid Arugument:" << ex_ia.what() << endl;
		return 1;
	}
	if (params.ShowVersion) {
		cout << Version << endl;
		cout << Copyright << endl;
	} else {
		try {
			UpdateCommand	command;
			command.Execute(params);
		} catch (DirectoryEntryPackage::ClassInitializeException & ex_c) {
			cout << endl << "ClassInitializeException:" << endl;
			cout << "    Method:" << ex_c.Method << endl;
			cout << "    Parameter:" << ex_c.Parameter << endl;
			cout << "    Value:" << ex_c.Value << endl;
			cout << "    ErrNo:" << ex_c.ErrNo << endl;
			cout << "    ErrMsg:" << ex_c.ErrMsg() << endl;
			return 1;
		} catch (DirectoryEntryPackage::ParameterNOTSpecifiedException & ex_p) {
			cout << endl << "ParameterNOTSpecifiedException:" << endl;
			cout << "    Method:" << ex_p.Method << endl;
			cout << "    Parameter:" << ex_p.Parameter << endl;
			cout << "    Value:" << ex_p.Value << endl;
			cout << "    ErrNo:" << ex_p.ErrNo << endl;
			cout << "    ErrMsg:" << ex_p.ErrMsg() << endl;
			return 1;
		} catch (DirectoryEntryPackage::IllegalParameterException & ex_i) {
			cout << endl << "IllegalParameterException:" << endl;
			cout << "    Method:" << ex_i.Method << endl;
			cout << "    Parameter:" << ex_i.Parameter << endl;
			cout << "    Value:" << ex_i.Value << endl;
			cout << "    ErrNo:" << ex_i.ErrNo << endl;
			cout << "    ErrMsg:" << ex_i.ErrMsg() << endl;
			return 1;
		} catch (DirectoryEntryPackage::EntryNOTFoundException & ex_e) {
			cout << endl << "EntryNOTFoundException:" << endl;
			cout << "    Method:" << ex_e.Method << endl;
			cout << "    Parameter:" << ex_e.Parameter << endl;
			cout << "    Value:" << ex_e.Value << endl;
			cout << "    ErrNo:" << ex_e.ErrNo << endl;
			cout << "    ErrMsg:" << ex_e.ErrMsg() << endl;
			return 1;
		} catch (UpdateCommandException & ex_u) {
			cout << endl << "UpdateCommandException:" << endl;
			cout << "    Method:" << ex_u.Method << endl;
			cout << "    Parameter:" << ex_u.Parameter << endl;
			cout << "    Message:" << ex_u.Msg << endl;
			cout << "    ErrNo:" << ex_u.ErrNo << endl;
			cout << "    ErrMsg:" << ex_u.ErrMsg() << endl;
			return 1;
		} catch (std::exception & ex) {
			cout << endl << "Unexpected Exception:" << ex.what() << endl;
			return 1;
		}
	}
	return 0;
}

/*-------1---------2---------3---------4---------5---------6---------7---------8---------9--------*/
/*  end of text */
